;List box demo
.586
.model flat, stdcall
option casemap:none

IdMenu equ 600
IdCmdExit equ 1000
IdCmdTest equ 1900

include \masm32\include\windows.inc

include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib

@h equ dword ptr[ebp+10h] ;on the stack are a return address, esi, edi, and ebp
@u equ dword ptr[ebp+14h]
@w equ dword ptr[ebp+18h]
@wl equ word ptr[ebp+18h]
@l equ dword ptr[ebp+1Ch]

;include \masm32\include\peek.inc
;@peek

.data
hWndMain dd 0
hWndList dd ?
MainWindow label dword  ;in reverse order, gets pushed for CreateWindowEx
    dd 0      ;window creation data (only for MDI)
  hInst2 dd ?
  hMenu dd 0
    dd 0      ;no parent or owner window
  MainWindowHeight dd 200
  MainWindowWidth dd 450
  MainWindowY dd 220
  MainWindowX dd 250
    dd WS_OVERLAPPEDWINDOW
    dd offset WindowName$
    dd offset ClassNameMain$
    dd 0    ;exStyle

ListBox label dword     ;for CreateWindowEx
    dd 0
  hInst3 dd ?
    dd 0
  hWndMain2 dd ?
    dd 200,200,0,0
    dd WS_OVERLAPPEDWINDOW or WS_CHILD or LBS_HASSTRINGS or WS_VSCROLL
    dd 0
    dd LISTBOX$
    dd 0     ;WS_EX_PALETTEWINDOW or WS_EX_CLIENTEDGE

MainWC label dword    ;for RegisterClassEx(ADDR wc)
    dd sizeof WNDCLASSEX
    dd CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW ;rather arbitrary
    dd offset WndProc
    dd 0,0             ;extra sizes wanted
  hInst1 dd ?
  hIcon dd ?
  hCursor dd 0
    dd 7 ;black
    dd 0      ;no default menu for this class
    dd offset ClassNameMain$
    dd 0      ;hIconSm

WindowName$ db "Skeleton",0
ClassNameMain$ db "SK_SV",0
LISTBOX$ db "LISTBOX",0   ;a class name

Exit$ db "E&xit",0
Test$ db "&Test",0

    .code
Done_1:
    mov eax,1
    jmp short Done_eax
Done_0:
    xor eax,eax
Done_eax:
    leave
    pop edi
    pop esi
    retn 10h
JmpDefWindowProc:
    leave
    pop edi
    pop esi
    jmp DefWindowProc

start:
    invoke GetModuleHandleA,0
    mov hInst1,eax
    mov hInst2,eax
    mov hInst3,eax

    invoke LoadCursorA,0,IDC_ARROW   ;0 for a system cursor.
    mov hCursor,eax

    call CreateMenu
    mov hMenu,eax
    invoke InsertMenu,eax,-1,MF_STRING+MF_BYPOSITION,IdCmdExit,addr Exit$
    invoke InsertMenu,hMenu,-1,MF_STRING+MF_BYPOSITION,IdCmdTest,addr Test$

    invoke RegisterClassExA,addr MainWC
    or eax,eax
    jz Quit_with_eax
    mov esi,offset MainWindow
    call CreateWindowExFromMem
    or hWndMain,eax
    mov hWndMain2,eax
    jz Quit_with_eax

    invoke SetMenu,eax,hMenu

    mov esi,offset ListBox
    call CreateWindowExFromMem
    mov hWndList,eax

    mov eax,hWndMain
    push eax       ;for UpdateWindow
    invoke ShowWindow,eax,SW_NORMAL
    call UpdateWindow

    call @F
    db "one",0
@@: push 0
    push LB_ADDSTRING
    push hWndList
    call SendMessageA

    call @F
    db "two",0
@@: push 0
    push LB_ADDSTRING
    push hWndList
    call SendMessageA

    mov eax,hWndList
    push eax       ;for UpdateWindow
    invoke ShowWindow,eax,SW_NORMAL
    call UpdateWindow
    sub esp,7*DWORD    ;make a buffer for a message structure
    mov ebp,esp
MsgLoop:
    invoke GetMessageA,ebp,0,0,0
    or eax,eax
    jz short Quit_with_wParam
    invoke TranslateMessage,ebp
    invoke DispatchMessageA,ebp
    jmp MsgLoop
Quit_with_wParam:
    mov eax,[ebp+8]  ;wParam
Quit_with_eax:
    invoke ExitProcess,eax

WndProc:
    push esi
    push edi
    push ebp
    mov ebp,esp
    mov eax,@u
    cmp eax,WM_DESTROY
    je HandleWM_DESTROY
    cmp eax,WM_COMMAND
    je HandleWM_COMMAND
    cmp eax,WM_CTLCOLORLISTBOX
    jne JmpDefWindowProc
;HandleWM_CTLCOLORLISTBOX:
    invoke SetBkMode,@w,TRANSPARENT
    invoke GetStockObject,GRAY_BRUSH
    jmp Done_eax

HandleWM_COMMAND:
    movzx eax,@wl     ;the command ID in the low word
    cmp eax,IdCmdExit
    je CmdExit
    cmp eax,IdCmdTest
    jne Done_0
;CmdTest:
    call @F
    db "three",0
@@: push 0
    push LB_ADDSTRING
    push hWndList
    call SendMessageA
    jmp Done_1

HandleWM_DESTROY:
    invoke PostQuitMessage,0
    jmp Done_0

CmdExit:
    invoke SendMessageA,@h,WM_SYSCOMMAND,SC_CLOSE,0
    jmp Done_1

CreateWindowExFromMem:     ;input is esi
    push (sizeof WNDCLASSEX)/4
    pop ecx
@@: lodsd
    push eax
    loop @B
    call CreateWindowExA
    ret

end start
